<!DOCTYPE html>
<html lang="en">
<head>
  <!--<link rel="stylesheet" href="{{url_for('static', filename='fontawesome.min.css')}}">-->
  <!--<script src="{{url_for('static', filename='jquery-3.6.4.min.js')}}"></script>-->
  <!--<script src="{{url_for('static', filename='d3-7.8.2.min.js')}}"></script>-->
  <meta charset="UTF-8">
  <title>Heizenergie</title>
</head>

<body>
  <h3>Zustand</h3>
  <div id="state_html">loading...</object></div>
  <h3>Zeitplan</h3>
  <div id="schedule_html">loading...</object></div>
  <h3>Aktionen</h3>
  <input type="datetime-local" name="" id="start">
  <input type="datetime-local" name="" id="end">
  <button type="button" id="reset">Reset</button>
  <button type="button" id="action_off">OFF</button>
  <button type="button" id="action_ns">NS</button>
  <button type="button" id="action_h1">H1</button>
  <button type="button" id="action_any">ANY</button>
  <p>old</p>
  <button type="button" id="switch_off">OFF</button>
  <button type="button" id="switch_ns">NS</button>
  <button type="button" id="switch_h1">H1</button>
  <h3>Preisübersicht</h3>
  <img id="prices_png" src="{{url_for('prices_png')}}" >
  <h3>Wetter</h3>
  <img id="weather_png" src="{{url_for('weather_png')}}" >

  <script defer>
    Date.prototype.addHours = function(h) {
      this.setTime(this.getTime() + (h*60*60*1000));
      return this;
    }

    function prefillDates() {
      var now = new Date();
      now.setMinutes(now.getMinutes() - now.getTimezoneOffset());
      /* remove second/millisecond */
      now.setMilliseconds(null);
      now.setSeconds(null);
      document.getElementById('start').value = now.toISOString().slice(0, -1);
      now.setMinutes(null);
      now.addHours(1);
      document.getElementById('end').value = now.toISOString().slice(0, -1);
    }

    var interval1 = 2000; // 2000 milis = 2 seconds
    var interval2 = 60000; // 60000 milis = 1 minute
    var interval3 = 600000; // 600000 milis = 10 minutes
    var prices = document.getElementById("prices_png");
    var weather = document.getElementById("weather_png");
    var state = document.getElementById("state_html");
    var schedule = document.getElementById("schedule_html");

    function updatePrices() {
      prices.src = prices.src.split("?")[0] + "?" + new Date().getTime();
    }

    function updateWeather() {
      weather.src = weather.src.split("?")[0] + "?" + new Date().getTime();
    }

    function updateState() {
      //text.innerHTML='<object type="text/html" data="state.html" ></object>';
      //state.data = state.data.split("?")[0] + "?" + new Date().getTime();
      fetch("{{url_for('state_html')}}" /*, options */)
      .then((response) => response.text())
      .then((html) => {
        state.innerHTML = html;
      })
      .catch((error) => {
        console.warn(error);
      });
    }

    function deleteAction(ref) {
      fetch("{{url_for('delete_action')}}?" + new URLSearchParams({start_iso: ref}),
      {
        method: "DELETE",
      })
        .then((response) => response.text())
        .then((text) => {
           console.warn(text);
        });
      updateSchedule();
      clearInterval(int2); /* Prices Chart */
      updatePrices();
      int2 = setInterval(updatePrices, interval2);
    }

    function updateSchedule() {
      fetch("{{url_for('schedule_html')}}" /*, options */)
      .then((response) => response.text())
      .then((html) => {
        schedule.innerHTML = html;
      })
      .catch((error) => {
        console.warn(error);
      });
    }

    var int1 = setInterval(updateState, interval1);
    var int2 = setInterval(updatePrices, interval2);
    var int3 = setInterval(updateWeather, interval3);

    function scheduleAdd(state) {
      fetch("{{url_for('schedule_add')}}",
      {
        method: "POST",
        headers: { "Content-Type": "application/json" },
        body: JSON.stringify({state: state, start: document.getElementById("start").value, end: document.getElementById("end").value})
      })
        .then((response) => response.text())
        .then((text) => {
           console.warn(text);
        });
      updateSchedule();
      clearInterval(int2); /* Prices Chart */
      updatePrices();
      int2 = setInterval(updatePrices, interval2);
    }

    function setState(state) {
      fetch("{{url_for('set_state')}}",
      {
        method: "POST",
        headers: { "Content-Type": "application/json" },
        body: JSON.stringify({state: state})
      })
        .then((response) => response.text())
        .then((text) => {
           console.warn(text);
        });
        return false;
    }

    prefillDates()
    updateSchedule()

    document.getElementById("reset").onclick = prefillDates;
    document.getElementById("action_off").onclick = function() { scheduleAdd('OFF'); };
    document.getElementById("action_ns").onclick = function() { scheduleAdd('NS'); };
    document.getElementById("action_h1").onclick = function() { scheduleAdd('H1'); };
    document.getElementById("action_any").onclick = function() { scheduleAdd('ANY'); };
    document.getElementById("switch_off").onclick = function() { setState('OFF'); };
    document.getElementById("switch_ns").onclick = function() { setState('NS'); };
    document.getElementById("switch_h1").onclick = function() { setState('H1'); };
  </script>

</body>
</html>
